'Kunstfeuer mit WS2812-Leds
$regfile = "m328pdef.dat"
$crystal = 16000000
$hwstack = 64
$swstack = 80
$framesize = 80

$baud = 9600


Config Base = 0
'*************************************************************
'user-Einstellungen
Const Num_leds = 40
'*************************************************************
$lib "Rainbow.lib"
$external Ws2812b
Declare Sub Select_rainbow(byval Channel As Byte)
Declare Sub Setcolor(byval Lednr As Word , Color() As Byte)
Declare Sub Send()
'#Rainbow
Const Rainbow0_len = Num_leds
Const Rainbow0_port = Portd
Const Rainbow0_pin = Pb4                                    'Pb0
Const Rainbow1_len = Num_leds
Const Rainbow1_port = Portd
Const Rainbow1_pin = Pb5                                    'Pb1
Const Rainbow2_len = Num_leds
Const Rainbow2_port = Portd
Const Rainbow2_pin = Pb2
Const Rainbow3_len = Num_leds
Const Rainbow3_port = Portd
Const Rainbow3_pin = Pb3

'BLuetooth by six1
   Config Pind.7 = Output
   Bt_cs Alias Portd.7
   Reset Bt_cs
   Waitms 10
   'Set Bt_cs

Config Serialin = Buffered , Size = 30 , Bytematch = 13
Dim Rx_flag As Byte
Rx_flag = 0

Dim Manuel_flag As Byte
Manuel_flag = 1

Dim On_flag As Byte
On_flag = 1

Dim Data_in As String * 31
Dim Command As String * 2
Dim Valstr As String * 10
Dim Rx_str As Byte
Rx_str = 0

Declare Sub Rx_data()
Declare Sub Rainbow_off


'Sekundentakt
Const Reload = 62500                                        ' bei 8MHz 31250
Config Date = Dmy , Separator = .
Config Clock = User
Config Timer1 = Timer , Prescale = 256
   Ocr1ah = High(reload)
   Ocr1al = Low(reload)
   Tccr1a = 0
   Set Tccr1b.3
On Compare1a Isr_timer1
Disable Compare1a

Dim New_second As Byte
New_second = 0
Dim Seconds_preload As Long                                 ' Sekunden zum herunterzhlen bis Abschaltung
Seconds_preload = 0
Dim Abschaltung As Byte
Abschaltung = 0

' Fire2012 by Mark Kriegsman, July 2012

Const Num_leds_1 = Num_leds - 1
Dim Cooling As Byte , Cooling_w As Word
Dim Sparking As Byte , Sparking_w As Word
Dim Spark As Byte , Spark_w As Word
Dim Heat(4 , Num_leds) As Byte
Dim N As Word , X As Integer , Y As Integer
Dim Feuer As Byte
Dim Farbe(3) As Byte
Rot Alias Farbe(_base)
Gruen Alias Farbe(_base + 1)
Blau Alias Farbe(_base + 2)
Dim Z As Byte
Dim Zeit As Word
Dim Yy As Byte

Enable Interrupts

'Change name of HC05
' for changing, uncomment two print lines.
' press button on HC05 modul and hold, while starting ATMega. After 3 Seconds, relase button; done...
'Print "AT+NAME=Ute Laterne 2"
'Print "AT+PSWD=0000"


Do


  If Abschaltung = 1 Then
   If New_second = 1 Then
    New_second = 0
    If Seconds_preload > 1 Then
      Decr Seconds_preload
      Time$ = Time(seconds_preload)
      If _hour = 0 And _min = 0 Then
         Print "=5" ; Chr(_hour) ; Chr(_min ) ; Chr(_sec )
      Elseif _sec = 0 Then
         Print "=5" ; Chr(_hour) ; Chr(_min ) ; Chr(_sec )
      End If
    Else
      ' Abschalten
      Disable Compare1a
      Print "=5" ; Chr(0) ; Chr(0 ) ; Chr(0 )
      On_flag = 0
      Call Rainbow_off
      Print "=00"
    End If
   End If
  End If


  If Manuel_flag = 1 Then
   'Potis einlesen
   ' 5..25
   Cooling_w = 5
   Cooling_w = Cooling_w / 52
   Cooling = Cooling_w + 5

   ' 120..200
   Sparking_w = 120
   Sparking_w = Sparking_w / 13
   Sparking = Sparking_w + 120

   ' 100..180
   Spark_w = 100
   Spark_w = Spark_w / 13
   Spark = Spark_w + 100
  End If


   If Rx_str > 0 Then
      Rx_str = 0
      Manuel_flag = 0
      Call Rx_data
   End If

   If On_flag = 1 Then
    For Feuer = 0 To 3
      Z = Feuer
' Step 1.  Cool down every cell a little
      For N = 0 To Num_leds_1
      'cooling=5..25      Hhe der Flamme mehr=groe Flamme
         X = 30 - Cooling : Y = Rnd(x) + 3
         If Y < Heat(z , N) Then Heat(z , N) = Heat(z , N) - Y Else Heat(z , N) = 0
      Next N

' Step 2. Heat From Each Cell Drifts                         'up' and diffuses a little
      For N = Num_leds_1 To 2 Step -1
         Y = N - 1 : X = Heat(z , Y)
         Y = N - 2 : X = X + Heat(z , Y) : X = X + Heat(z , Y)
         X = X / 3
         Heat(z , N) = X
      Next N

' Step 3.  Randomly ignite new 'sparks' of heat near the bottom
      'sparking=120 ..200  Hufigkeit der Nachzndungen weniger=gleichmigeres Feuer
      If Sparking < Rnd(255) Then
         X = Rnd(3)
      'spark=100..180      Hitze der Nachzndungen mehr=weiere Nachzndungen
         Y = Spark + Rnd(76)
         Heat(z , X) = Y
      End If
' Step 4.  Map from heat cells to LED colors
      Call Select_rainbow(feuer)
      For N = 0 To Num_leds_1
         X = Heat(z , N)
         X = X * 6
         Rot = Lookup(x , Farben)
         X = X + 1 : Gruen = Lookup(x , Farben)
         X = X + 1 : Blau = Lookup(x , Farben)
         Call Setcolor(n , Farbe())
      Next N
      Waitms 1
      Call Select_rainbow(feuer)
      Call Send()
      Waitms 2
    Next Feuer
   End If
Loop
End

Isr_timer1:
   New_second = 1
Return

Sub Rainbow_off
      For Feuer = 0 To 3
         Call Select_rainbow(feuer)
         For N = 0 To Num_leds_1
            X = Heat(z , N)
            X = X * 6
            Rot = 0
            X = X + 1 : Gruen = 0
            X = X + 1 : Blau = 0
            Call Setcolor(n , Farbe())
          Next N
          Waitms 1
          Call Select_rainbow(feuer)
          Call Send()
      Next Feuer
End Sub

Sub Rx_data()
  Local Pos_start As Byte
  Local Pos As Byte
  '     Reset Watchdog
       Pos_start = Charpos(data_in , "=")
       If Pos_start = 0 Then
         Data_in = ""
         Exit Sub
       End If

       Pos = Len(data_in) - Pos_start
       Incr Pos
       Data_in = Mid(data_in , Pos_start , Pos)

       Command = Mid(data_in , 1 , 2)
'Print Data_in
'Print Command
       ' on/off
       If Command = "=0" Then
            Valstr = Mid(data_in , 3 , 1)
            If Valstr = "0" Then
              On_flag = 0
              Abschaltung = 0
              Disable Compare1a
              Call Rainbow_off
            Else
              On_flag = 1
            End If
       Elseif Command = "=1" Then
          ' Cooling
            Pos = Len(data_in) - 2
            Valstr = Mid(data_in , 3 , Pos)
           'cooling=5..25      Hhe der Flamme mehr=groe Flamme
           'wird mit +20 gesendet, damit chr(13) nicht im Zeichenvorrat ist!
            Cooling = Val(valstr)
            Cooling = Cooling - 20
       Elseif Command = "=2" Then
          ' Sparking
            Pos = Len(data_in) - 2
            Valstr = Mid(data_in , 3 , Pos)
           'sparking=120 ..200  Hufigkeit der Nachzndungen weniger=gleichmigeres Feuer
            Sparking = Val(valstr)
       Elseif Command = "=3" Then
          ' Spark
            Pos = Len(data_in) - 2
            Valstr = Mid(data_in , 3 , Pos)
            'spark=100..180      Hitze der Nachzndungen mehr=weiere Nachzndungen
            Spark = Val(valstr)
       Elseif Command = "=4" Then
            ' Preset Flamme einstellen
            Valstr = Mid(data_in , 3 , 1)
           'cooling=5..25      Abkhlung der Flamme mehr=kleine Flamme
           'wird mit +20 gesendet, damit chr(13) nicht im Zeichenvorrat ist!
            Cooling = Asc(valstr)
            Cooling = Cooling - 20

            Valstr = Mid(data_in , 4 , 1)
           'sparking=120 ..200  Hufigkeit der Nachzndungen weniger=gleichmigeres Feuer
            Sparking = Asc(valstr)

            Valstr = Mid(data_in , 5 , 1)
            'spark=100..180      Hitze der Nachzndungen mehr=weiere Nachzndungen
            Spark = Asc(valstr)
       Elseif Command = "=5" Then
          ' Abschalttimer
            Pos = Len(data_in) - 2
            Valstr = Mid(data_in , 3 , Pos)
            Seconds_preload = Val(valstr)
            Abschaltung = 1
            On_flag = 1
            Time$ = Time(seconds_preload)
            Print "=5" ; Chr(_hour) ; Chr(_min ) ; Chr(_sec )
            Enable Compare1a
       Elseif Command = "=6" Then
           ' komplette Einstellungen senden
            Z = Cooling + 20
            Print "=6" ; Chr(on_flag) ; Chr(z ) ; Chr(sparking ) ; Chr(spark )
       End If

       Data_in = ""
End Sub

Serial0charmatch:
'   Pushall
   Input Data_in Noecho
   Rx_str = 1
'   Popall
Return

Setdate:
Return

Settime:
Return


Farben:
  'http://soliton.vm.bytemark.co.uk/pub/cpt-city/kst/03_red_temperature.c3g
   Data 0 , 0 , 0
   Data 0 , 0 , 0                                             ' 0.390%,
   Data 1 , 0 , 0                                             '   0.390%,
   Data 1 , 0 , 0                                             '   0.780%,
   Data 2 , 0 , 0                                             '   0.780%,
   Data 2 , 0 , 0                                             '   1.170%,
   Data 4 , 0 , 0                                             '   1.170%,
   Data 4 , 0 , 0                                             '   1.560%,
   Data 5 , 0 , 0                                             '   1.560%,
   Data 5 , 0 , 0                                             '   1.950%,
   Data 7 , 0 , 0                                             '   1.950%,
   Data 7 , 0 , 0                                             '   2.340%,
   Data 8 , 0 , 0                                             '   2.340%,
   Data 8 , 0 , 0                                             '   2.730%,
   Data 10 , 0 , 0                                            '   2.730%,
   Data 10 , 0 , 0                                            '   3.120%,
   Data 11 , 0 , 0                                            '   3.120%,
   Data 11 , 0 , 0                                            '   3.520%,
   Data 13 , 0 , 0                                            '   3.520%,
   Data 13 , 0 , 0                                            '   3.910%,
   Data 14 , 0 , 0                                            '   3.910%,
   Data 14 , 0 , 0                                            '   4.300%,
   Data 15 , 0 , 0                                            '   4.300%,
   Data 15 , 0 , 0                                            '   4.690%,
   Data 17 , 0 , 0                                            '   4.690%,
   Data 17 , 0 , 0                                            '   5.080%,
   Data 18 , 0 , 0                                            '   5.080%,
   Data 18 , 0 , 0                                            '   5.470%,
   Data 20 , 0 , 0                                            '   5.470%,
   Data 20 , 0 , 0                                            '   5.860%,
   Data 21 , 0 , 0                                            '   5.860%,
   Data 21 , 0 , 0                                            '   6.250%,
   Data 23 , 0 , 0                                            '   6.250%,
   Data 23 , 0 , 0                                            '   6.640%,
   Data 24 , 0 , 0                                            '   6.640%,
   Data 24 , 0 , 0                                            '   7.030%,
   Data 26 , 0 , 0                                            '   7.030%,
   Data 26 , 0 , 0                                            '   7.420%,
   Data 27 , 0 , 0                                            '   7.420%,
   Data 27 , 0 , 0                                            '   7.810%,
   Data 28 , 0 , 0                                            '   7.810%,
   Data 28 , 0 , 0                                            '   8.200%,
   Data 30 , 0 , 0                                            '   8.200%,
   Data 30 , 0 , 0                                            '   8.590%,
   Data 31 , 0 , 0                                            '   8.590%,
   Data 31 , 0 , 0                                            '   8.980%,
   Data 33 , 0 , 0                                            '   8.980%,
   Data 33 , 0 , 0                                            '   9.380%,
   Data 34 , 0 , 0                                            '   9.380%,
   Data 34 , 0 , 0                                            '   9.770%,
   Data 36 , 0 , 0                                            '   9.770%,
   Data 36 , 0 , 0                                            '  10.160%,
   Data 37 , 0 , 0                                            '  10.160%,
   Data 37 , 0 , 0                                            '  10.550%,
   Data 39 , 0 , 0                                            '  10.550%,
   Data 39 , 0 , 0                                            '  10.940%,
   Data 40 , 0 , 0                                            '  10.940%,
   Data 40 , 0 , 0                                            '  11.330%,
   Data 42 , 0 , 0                                            '  11.330%,
   Data 42 , 0 , 0                                            '  11.720%,
   Data 43 , 0 , 0                                            '  11.720%,
   Data 43 , 0 , 0                                            '  12.110%,
   Data 44 , 0 , 0                                            '  12.110%,
   Data 44 , 0 , 0                                            '  12.500%,
   Data 46 , 0 , 0                                            '  12.500%,
   Data 46 , 0 , 0                                            '  12.890%,
   Data 47 , 0 , 0                                            '  12.890%,
   Data 47 , 0 , 0                                            '  13.280%,
   Data 49 , 0 , 0                                            '  13.280%,
   Data 49 , 0 , 0                                            '  13.670%,
   Data 50 , 0 , 0                                            '  13.670%,
   Data 50 , 0 , 0                                            '  14.060%,
   Data 52 , 0 , 0                                            '  14.060%,
   Data 52 , 0 , 0                                            '  14.450%,
   Data 53 , 0 , 0                                            '  14.450%,
   Data 53 , 0 , 0                                            '  14.840%,
   Data 55 , 0 , 0                                            '  14.840%,
   Data 55 , 0 , 0                                            '  15.230%,
   Data 56 , 0 , 0                                            '  15.230%,
   Data 56 , 0 , 0                                            '  15.620%,
   Data 57 , 0 , 0                                            '  15.620%,
   Data 57 , 0 , 0                                            '  16.020%,
   Data 59 , 0 , 0                                            '  16.020%,
   Data 59 , 0 , 0                                            '  16.410%,
   Data 60 , 0 , 0                                            '  16.410%,
   Data 60 , 0 , 0                                            '  16.800%,
   Data 62 , 0 , 0                                            '  16.800%,
   Data 62 , 0 , 0                                            '  17.190%,
   Data 63 , 0 , 0                                            '  17.190%,
   Data 63 , 0 , 0                                            '  17.580%,
   Data 65 , 0 , 0                                            '  17.580%,
   Data 65 , 0 , 0                                            '  17.970%,
   Data 66 , 0 , 0                                            '  17.970%,
   Data 66 , 0 , 0                                            '  18.360%,
   Data 68 , 0 , 0                                            '  18.360%,
   Data 68 , 0 , 0                                            '  18.750%,
   Data 69 , 0 , 0                                            '  18.750%,
   Data 69 , 0 , 0                                            '  19.140%,
   Data 70 , 0 , 0                                            '  19.140%,
   Data 70 , 0 , 0                                            '  19.530%,
   Data 72 , 0 , 0                                            '  19.530%,
   Data 72 , 0 , 0                                            '  19.920%,
   Data 73 , 0 , 0                                            '  19.920%,
   Data 73 , 0 , 0                                            '  20.310%,
   Data 75 , 0 , 0                                            '  20.310%,
   Data 75 , 0 , 0                                            '  20.700%,
   Data 76 , 0 , 0                                            '  20.700%,
   Data 76 , 0 , 0                                            '  21.090%,
   Data 78 , 0 , 0                                            '  21.090%,
   Data 78 , 0 , 0                                            '  21.480%,
   Data 79 , 0 , 0                                            '  21.480%,
   Data 79 , 0 , 0                                            '  21.880%,
   Data 81 , 0 , 0                                            '  21.880%,
   Data 81 , 0 , 0                                            '  22.270%,
   Data 82 , 0 , 0                                            '  22.270%,
   Data 82 , 0 , 0                                            '  22.660%,
   Data 84 , 0 , 0                                            '  22.660%,
   Data 84 , 0 , 0                                            '  23.050%,
   Data 85 , 0 , 0                                            '  23.050%,
   Data 85 , 0 , 0                                            '  23.440%,
   Data 86 , 0 , 0                                            '  23.440%,
   Data 86 , 0 , 0                                            '  23.830%,
   Data 88 , 0 , 0                                            '  23.830%,
   Data 88 , 0 , 0                                            '  24.220%,
   Data 89 , 0 , 0                                            '  24.220%,
   Data 89 , 0 , 0                                            '  24.610%,
   Data 91 , 0 , 0                                            '  24.610%,
   Data 91 , 0 , 0                                            '  25.000%,
   Data 92 , 0 , 0                                            '  25.000%,
   Data 92 , 0 , 0                                            '  25.390%,
   Data 94 , 0 , 0                                            '  25.390%,
   Data 94 , 0 , 0                                            '  25.780%,
   Data 95 , 0 , 0                                            '  25.780%,
   Data 95 , 0 , 0                                            '  26.170%,
   Data 97 , 0 , 0                                            '  26.170%,
   Data 97 , 0 , 0                                            '  26.560%,
   Data 98 , 0 , 0                                            '  26.560%,
   Data 98 , 0 , 0                                            '  26.950%,
   Data 99 , 0 , 0                                            '  26.950%,
   Data 99 , 0 , 0                                            '  27.340%,
   Data 101 , 0 , 0                                           '  27.340%,
   Data 101 , 0 , 0                                           '  27.730%,
   Data 102 , 0 , 0                                           '  27.730%,
   Data 102 , 0 , 0                                           '  28.120%,
   Data 104 , 0 , 0                                           '  28.120%,
   Data 104 , 0 , 0                                           '  28.520%,
   Data 105 , 0 , 0                                           '  28.520%,
   Data 105 , 0 , 0                                           '  28.910%,
   Data 107 , 0 , 0                                           '  28.910%,
   Data 107 , 0 , 0                                           '  29.300%,
   Data 108 , 0 , 0                                           '  29.300%,
   Data 108 , 0 , 0                                           '  29.690%,
   Data 110 , 0 , 0                                           '  29.690%,
   Data 110 , 0 , 0                                           '  30.080%,
   Data 111 , 0 , 0                                           '  30.080%,
   Data 111 , 0 , 0                                           '  30.470%,
   Data 113 , 0 , 0                                           '  30.470%,
   Data 113 , 0 , 0                                           '  30.860%,
   Data 114 , 0 , 0                                           '  30.860%,
   Data 114 , 0 , 0                                           '  31.250%,
   Data 115 , 0 , 0                                           '  31.250%,
   Data 115 , 0 , 0                                           '  31.640%,
   Data 117 , 0 , 0                                           '  31.640%,
   Data 117 , 0 , 0                                           '  32.030%,
   Data 118 , 0 , 0                                           '  32.030%,
   Data 118 , 0 , 0                                           '  32.420%,
   Data 120 , 0 , 0                                           '  32.420%,
   Data 120 , 0 , 0                                           '  32.810%,
   Data 121 , 0 , 0                                           '  32.810%,
   Data 121 , 0 , 0                                           '  33.200%,
   Data 123 , 0 , 0                                           '  33.200%,
   Data 123 , 0 , 0                                           '  33.590%,
   Data 124 , 0 , 0                                           '  33.590%,
   Data 124 , 0 , 0                                           '  33.980%,
   Data 126 , 0 , 0                                           '  33.980%,
   Data 126 , 0 , 0                                           '  34.380%,
   Data 127 , 0 , 0                                           '  34.380%,
   Data 127 , 0 , 0                                           '  34.770%,
   Data 128 , 0 , 0                                           '  34.770%,
   Data 128 , 0 , 0                                           '  35.160%,
   Data 130 , 0 , 0                                           '  35.160%,
   Data 130 , 0 , 0                                           '  35.550%,
   Data 131 , 0 , 0                                           '  35.550%,
   Data 131 , 0 , 0                                           '  35.940%,
   Data 133 , 0 , 0                                           '  35.940%,
   Data 133 , 0 , 0                                           '  36.330%,
   Data 134 , 0 , 0                                           '  36.330%,
   Data 134 , 0 , 0                                           '  36.720%,
   Data 136 , 0 , 0                                           '  36.720%,
   Data 136 , 0 , 0                                           '  37.110%,
   Data 137 , 0 , 0                                           '  37.110%,
   Data 137 , 0 , 0                                           '  37.500%,
   Data 139 , 0 , 0                                           '  37.500%,
   Data 139 , 0 , 0                                           '  37.890%,
   Data 140 , 0 , 0                                           '  37.890%,
   Data 140 , 0 , 0                                           '  38.280%,
   Data 141 , 0 , 0                                           '  38.280%,
   Data 141 , 0 , 0                                           '  38.670%,
   Data 143 , 0 , 0                                           '  38.670%,
   Data 143 , 0 , 0                                           '  39.060%,
   Data 144 , 0 , 0                                           '  39.060%,
   Data 144 , 0 , 0                                           '  39.450%,
   Data 146 , 0 , 0                                           '  39.450%,
   Data 146 , 0 , 0                                           '  39.840%,
   Data 147 , 0 , 0                                           '  39.840%,
   Data 147 , 0 , 0                                           '  40.230%,
   Data 149 , 0 , 0                                           '  40.230%,
   Data 149 , 0 , 0                                           '  40.620%,
   Data 150 , 0 , 0                                           '  40.620%,
   Data 150 , 0 , 0                                           '  41.020%,
   Data 152 , 0 , 0                                           '  41.020%,
   Data 152 , 0 , 0                                           '  41.410%,
   Data 153 , 0 , 0                                           '  41.410%,
   Data 153 , 0 , 0                                           '  41.800%,
   Data 155 , 0 , 0                                           '  41.800%,
   Data 155 , 0 , 0                                           '  42.190%,
   Data 156 , 0 , 0                                           '  42.190%,
   Data 156 , 0 , 0                                           '  42.580%,
   Data 157 , 0 , 0                                           '  42.580%,
   Data 157 , 0 , 0                                           '  42.970%,
   Data 159 , 0 , 0                                           '  42.970%,
   Data 159 , 0 , 0                                           '  43.360%,
   Data 160 , 0 , 0                                           '  43.360%,
   Data 160 , 0 , 0                                           '  43.750%,
   Data 162 , 0 , 0                                           '  43.750%,
   Data 162 , 0 , 0                                           '  44.140%,
   Data 163 , 0 , 0                                           '  44.140%,
   Data 163 , 0 , 0                                           '  44.530%,
   Data 165 , 0 , 0                                           '  44.530%,
   Data 165 , 0 , 0                                           '  44.920%,
   Data 166 , 0 , 0                                           '  44.920%,
   Data 166 , 0 , 0                                           '  45.310%,
   Data 168 , 0 , 0                                           '  45.310%,
   Data 168 , 0 , 0                                           '  45.700%,
   Data 169 , 0 , 0                                           '  45.700%,
   Data 169 , 0 , 0                                           '  46.090%,
   Data 170 , 0 , 0                                           '  46.090%,
   Data 170 , 0 , 0                                           '  46.480%,
   Data 172 , 0 , 0                                           '  46.480%,
   Data 172 , 0 , 0                                           '  46.880%,
   Data 173 , 0 , 0                                           '  46.880%,
   Data 173 , 0 , 0                                           '  47.270%,
   Data 175 , 1 , 0                                           '  47.270%,
   Data 175 , 1 , 0                                           '  47.660%,
   Data 176 , 3 , 0                                           '  47.660%,
   Data 176 , 3 , 0                                           '  48.050%,
   Data 178 , 5 , 0                                           '  48.050%,
   Data 178 , 5 , 0                                           '  48.440%,
   Data 179 , 7 , 0                                           '  48.440%,
   Data 179 , 7 , 0                                           '  48.830%,
   Data 181 , 9 , 0                                           '  48.830%,
   Data 181 , 9 , 0                                           '  49.220%,
   Data 182 , 11 , 0                                          '  49.220%,
   Data 182 , 11 , 0                                          '  49.610%,
   Data 184 , 13 , 0                                          '  49.610%,
   Data 184 , 13 , 0                                          '  50.000%,
   Data 185 , 15 , 0                                          '  50.000%,
   Data 185 , 15 , 0                                          '  50.390%,
   Data 186 , 17 , 0                                          '  50.390%,
   Data 186 , 17 , 0                                          '  50.780%,
   Data 188 , 18 , 0                                          '  50.780%,
   Data 188 , 18 , 0                                          '  51.170%,
   Data 189 , 20 , 0                                          '  51.170%,
   Data 189 , 20 , 0                                          '  51.560%,
   Data 191 , 22 , 0                                          '  51.560%,
   Data 191 , 22 , 0                                          '  51.950%,
   Data 192 , 24 , 0                                          '  51.950%,
   Data 192 , 24 , 0                                          '  52.340%,
   Data 194 , 26 , 0                                          '  52.340%,
   Data 194 , 26 , 0                                          '  52.730%,
   Data 195 , 28 , 0                                          '  52.730%,
   Data 195 , 28 , 0                                          '  53.120%,
   Data 197 , 30 , 0                                          '  53.120%,
   Data 197 , 30 , 0                                          '  53.520%,
   Data 198 , 32 , 0                                          '  53.520%,
   Data 198 , 32 , 0                                          '  53.910%,
   Data 199 , 34 , 0                                          '  53.910%,
   Data 199 , 34 , 0                                          '  54.300%,
   Data 201 , 35 , 0                                          '  54.300%,
   Data 201 , 35 , 0                                          '  54.690%,
   Data 202 , 37 , 0                                          '  54.690%,
   Data 202 , 37 , 0                                          '  55.080%,
   Data 204 , 39 , 0                                          '  55.080%,
   Data 204 , 39 , 0                                          '  55.470%,
   Data 205 , 41 , 0                                          '  55.470%,
   Data 205 , 41 , 0                                          '  55.860%,
   Data 207 , 43 , 0                                          '  55.860%,
   Data 207 , 43 , 0                                          '  56.250%,
   Data 208 , 45 , 0                                          '  56.250%,
   Data 208 , 45 , 0                                          '  56.640%,
   Data 210 , 47 , 0                                          '  56.640%,
   Data 210 , 47 , 0                                          '  57.030%,
   Data 211 , 49 , 0                                          '  57.030%,
   Data 211 , 49 , 0                                          '  57.420%,
   Data 212 , 51 , 0                                          '  57.420%,
   Data 212 , 51 , 0                                          '  57.810%,
   Data 214 , 52 , 0                                          '  57.810%,
   Data 214 , 52 , 0                                          '  58.200%,
   Data 215 , 54 , 0                                          '  58.200%,
   Data 215 , 54 , 0                                          '  58.590%,
   Data 217 , 56 , 0                                          '  58.590%,
   Data 217 , 56 , 0                                          '  58.980%,
   Data 218 , 58 , 0                                          '  58.980%,
   Data 218 , 58 , 0                                          '  59.380%,
   Data 220 , 60 , 0                                          '  59.380%,
   Data 220 , 60 , 0                                          '  59.770%,
   Data 221 , 62 , 0                                          '  59.770%,
   Data 221 , 62 , 0                                          '  60.160%,
   Data 223 , 64 , 0                                          '  60.160%,
   Data 223 , 64 , 0                                          '  60.550%,
   Data 224 , 66 , 0                                          '  60.550%,
   Data 224 , 66 , 0                                          '  60.940%,
   Data 226 , 68 , 0                                          '  60.940%,
   Data 226 , 68 , 0                                          '  61.330%,
   Data 227 , 69 , 0                                          '  61.330%,
   Data 227 , 69 , 0                                          '  61.720%,
   Data 228 , 71 , 0                                          '  61.720%,
   Data 228 , 71 , 0                                          '  62.110%,
   Data 230 , 73 , 0                                          '  62.110%,
   Data 230 , 73 , 0                                          '  62.500%,
   Data 231 , 75 , 0                                          '  62.500%,
   Data 231 , 75 , 0                                          '  62.890%,
   Data 233 , 77 , 0                                          '  62.890%,
   Data 233 , 77 , 0                                          '  63.280%,
   Data 234 , 79 , 0                                          '  63.280%,
   Data 234 , 79 , 0                                          '  63.670%,
   Data 236 , 81 , 0                                          '  63.670%,
   Data 236 , 81 , 0                                          '  64.060%,
   Data 237 , 83 , 0                                          '  64.060%,
   Data 237 , 83 , 0                                          '  64.450%,
   Data 239 , 85 , 0                                          '  64.450%,
   Data 239 , 85 , 0                                          '  64.840%,
   Data 240 , 86 , 0                                          '  64.840%,
   Data 240 , 86 , 0                                          '  65.230%,
   Data 241 , 88 , 0                                          '  65.230%,
   Data 241 , 88 , 0                                          '  65.620%,
   Data 243 , 90 , 0                                          '  65.620%,
   Data 243 , 90 , 0                                          '  66.020%,
   Data 244 , 92 , 0                                          '  66.020%,
   Data 244 , 92 , 0                                          '  66.410%,
   Data 246 , 94 , 0                                          '  66.410%,
   Data 246 , 94 , 0                                          '  66.800%,
   Data 247 , 96 , 0                                          '  66.800%,
   Data 247 , 96 , 0                                          '  67.190%,
   Data 249 , 98 , 0                                          '  67.190%,
   Data 249 , 98 , 0                                          '  67.580%,
   Data 250 , 100 , 0                                         '  67.580%,
   Data 250 , 100 , 0                                         '  67.970%,
   Data 252 , 102 , 0                                         '  67.970%,
   Data 252 , 102 , 0                                         '  68.360%,
   Data 253 , 103 , 0                                         '  68.360%,
   Data 253 , 103 , 0                                         '  68.750%,
   Data 255 , 105 , 0                                         '  68.750%,
   Data 255 , 105 , 0                                         '  69.140%,
   Data 255 , 107 , 0                                         '  69.140%,
   Data 255 , 107 , 0                                         '  69.530%,
   Data 255 , 109 , 0                                         '  69.530%,
   Data 255 , 109 , 0                                         '  69.920%,
   Data 255 , 111 , 0                                         '  69.920%,
   Data 255 , 111 , 0                                         '  70.310%,
   Data 255 , 113 , 0                                         '  70.310%,
   Data 255 , 113 , 0                                         '  70.700%,
   Data 255 , 115 , 0                                         '  70.700%,
   Data 255 , 115 , 0                                         '  71.090%,
   Data 255 , 117 , 0                                         '  71.090%,
   Data 255 , 117 , 0                                         '  71.480%,
   Data 255 , 119 , 0                                         '  71.480%,
   Data 255 , 119 , 0                                         '  71.880%,
   Data 255 , 120 , 0                                         '  71.880%,
   Data 255 , 120 , 0                                         '  72.270%,
   Data 255 , 122 , 0                                         '  72.270%,
   Data 255 , 122 , 0                                         '  72.660%,
   Data 255 , 124 , 0                                         '  72.660%,
   Data 255 , 124 , 0                                         '  73.050%,
   Data 255 , 126 , 0                                         '  73.050%,
   Data 255 , 126 , 0                                         '  73.440%,
   Data 255 , 128 , 0                                         '  73.440%,
   Data 255 , 128 , 0                                         '  73.830%,
   Data 255 , 130 , 0                                         '  73.830%,
   Data 255 , 130 , 0                                         '  74.220%,
   Data 255 , 132 , 0                                         '  74.220%,
   Data 255 , 132 , 0                                         '  74.610%,
   Data 255 , 134 , 3                                         '  74.610%,
   Data 255 , 134 , 3                                         '  75.000%,
   Data 255 , 136 , 7                                         '  75.000%,
   Data 255 , 136 , 7                                         '  75.390%,
   Data 255 , 137 , 11                                        '  75.390%,
   Data 255 , 137 , 11                                        '  75.780%,
   Data 255 , 139 , 15                                        '  75.780%,
   Data 255 , 139 , 15                                        '  76.170%,
   Data 255 , 141 , 19                                        '  76.170%,
   Data 255 , 141 , 19                                        '  76.560%,
   Data 255 , 143 , 23                                        '  76.560%,
   Data 255 , 143 , 23                                        '  76.950%,
   Data 255 , 145 , 27                                        '  76.950%,
   Data 255 , 145 , 27                                        '  77.340%,
   Data 255 , 147 , 31                                        '  77.340%,
   Data 255 , 147 , 31                                        '  77.730%,
   Data 255 , 149 , 35                                        '  77.730%,
   Data 255 , 149 , 35                                        '  78.120%,
   Data 255 , 151 , 39                                        '  78.120%,
   Data 255 , 151 , 39                                        '  78.520%,
   Data 255 , 153 , 43                                        '  78.520%,
   Data 255 , 153 , 43                                        '  78.910%,
   Data 255 , 154 , 47                                        '  78.910%,
   Data 255 , 154 , 47                                        '  79.300%,
   Data 255 , 156 , 51                                        '  79.300%,
   Data 255 , 156 , 51                                        '  79.690%,
   Data 255 , 158 , 54                                        '  79.690%,
   Data 255 , 158 , 54                                        '  80.080%,
   Data 255 , 160 , 58                                        '  80.080%,
   Data 255 , 160 , 58                                        '  80.470%,
   Data 255 , 162 , 62                                        '  80.470%,
   Data 255 , 162 , 62                                        '  80.860%,
   Data 255 , 164 , 66                                        '  80.860%,
   Data 255 , 164 , 66                                        '  81.250%,
   Data 255 , 166 , 70                                        '  81.250%,
   Data 255 , 166 , 70                                        '  81.640%,
   Data 255 , 168 , 74                                        '  81.640%,
   Data 255 , 168 , 74                                        '  82.030%,
   Data 255 , 170 , 78                                        '  82.030%,
   Data 255 , 170 , 78                                        '  82.420%,
   Data 255 , 171 , 82                                        '  82.420%,
   Data 255 , 171 , 82                                        '  82.810%,
   Data 255 , 173 , 86                                        '  82.810%,
   Data 255 , 173 , 86                                        '  83.200%,
   Data 255 , 175 , 90                                        '  83.200%,
   Data 255 , 175 , 90                                        '  83.590%,
   Data 255 , 177 , 94                                        '  83.590%,
   Data 255 , 177 , 94                                        '  83.980%,
   Data 255 , 179 , 98                                        '  83.980%,
   Data 255 , 179 , 98                                        '  84.380%,
   Data 255 , 181 , 102                                       '  84.380%,
   Data 255 , 181 , 102                                       '  84.770%,
   Data 255 , 183 , 105                                       '  84.770%,
   Data 255 , 183 , 105                                       '  85.160%,
   Data 255 , 185 , 109                                       '  85.160%,
   Data 255 , 185 , 109                                       '  85.550%,
   Data 255 , 187 , 113                                       '  85.550%,
   Data 255 , 187 , 113                                       '  85.940%,
   Data 255 , 188 , 117                                       '  85.940%,
   Data 255 , 188 , 117                                       '  86.330%,
   Data 255 , 190 , 121                                       '  86.330%,
   Data 255 , 190 , 121                                       '  86.720%,
   Data 255 , 192 , 125                                       '  86.720%,
   Data 255 , 192 , 125                                       '  87.110%,
   Data 255 , 194 , 129                                       '  87.110%,
   Data 255 , 194 , 129                                       '  87.500%,
   Data 255 , 196 , 133                                       '  87.500%,
   Data 255 , 196 , 133                                       '  87.890%,
   Data 255 , 198 , 137                                       '  87.890%,
   Data 255 , 198 , 137                                       '  88.280%,
   Data 255 , 200 , 141                                       '  88.280%,
   Data 255 , 200 , 141                                       '  88.670%,
   Data 255 , 202 , 145                                       '  88.670%,
   Data 255 , 202 , 145                                       '  89.060%,
   Data 255 , 204 , 149                                       '  89.060%,
   Data 255 , 204 , 149                                       '  89.450%,
   Data 255 , 205 , 153                                       '  89.450%,
   Data 255 , 205 , 153                                       '  89.840%,
   Data 255 , 207 , 156                                       '  89.840%,
   Data 255 , 207 , 156                                       '  90.230%,
   Data 255 , 209 , 160                                       '  90.230%,
   Data 255 , 209 , 160                                       '  90.620%,
   Data 255 , 211 , 164                                       '  90.620%,
   Data 255 , 211 , 164                                       '  91.020%,
   Data 255 , 213 , 168                                       '  91.020%,
   Data 255 , 213 , 168                                       '  91.410%,
   Data 255 , 215 , 172                                       '  91.410%,
   Data 255 , 215 , 172                                       '  91.800%,
   Data 255 , 217 , 176                                       '  91.800%,
   Data 255 , 217 , 176                                       '  92.190%,
   Data 255 , 219 , 180                                       '  92.190%,
   Data 255 , 219 , 180                                       '  92.580%,
   Data 255 , 221 , 184                                       '  92.580%,
   Data 255 , 221 , 184                                       '  92.970%,
   Data 255 , 222 , 188                                       '  92.970%,
   Data 255 , 222 , 188                                       '  93.360%,
   Data 255 , 224 , 192                                       '  93.360%,
   Data 255 , 224 , 192                                       '  93.750%,
   Data 255 , 226 , 196                                       '  93.750%,
   Data 255 , 226 , 196                                       '  94.140%,
   Data 255 , 228 , 200                                       '  94.140%,
   Data 255 , 228 , 200                                       '  94.530%,
   Data 255 , 230 , 204                                       '  94.530%,
   Data 255 , 230 , 204                                       '  94.920%,
   Data 255 , 232 , 207                                       '  94.920%,
   Data 255 , 232 , 207                                       '  95.310%,
   Data 255 , 234 , 211                                       '  95.310%,
   Data 255 , 234 , 211                                       '  95.700%,
   Data 255 , 236 , 215                                       '  95.700%,
   Data 255 , 236 , 215                                       '  96.090%,
   Data 255 , 238 , 219                                       '  96.090%,
   Data 255 , 238 , 219                                       '  96.480%,
   Data 255 , 239 , 223                                       '  96.480%,
   Data 255 , 239 , 223                                       '  96.880%,
   Data 255 , 241 , 227                                       '  96.880%,
   Data 255 , 241 , 227                                       '  97.270%,
   Data 255 , 243 , 231                                       '  97.270%,
   Data 255 , 243 , 231                                       '  97.660%,
   Data 255 , 245 , 235                                       '  97.660%,
   Data 255 , 245 , 235                                       '  98.050%,
   Data 255 , 247 , 239                                       '  98.050%,
   Data 255 , 247 , 239                                       '  98.440%,
   Data 255 , 249 , 243                                       '  98.440%,
   Data 255 , 249 , 243                                       '  98.830%,
   Data 255 , 251 , 247                                       '  98.830%,
   Data 255 , 251 , 247                                       '  99.220%,
   Data 255 , 253 , 251                                       '  99.220%,
   Data 255 , 253 , 251                                       '  99.610%,
   Data 255 , 255 , 255                                       '  99.610%,
   Data 255 , 255 , 255                                       ' 100.000%